<template>
	<a-card :bordered="false">
		<a-form ref="searchFormRef" name="advanced_search" :model="searchFormState" class="ant-advanced-search-form">
			<a-row :gutter="24">
				<a-col :span="6">
					<a-form-item label="关键词" name="searchKey">
						<a-input v-model:value="searchFormState.searchKey" placeholder="姓名/电话/邮箱"/>
					</a-form-item>
				</a-col>

				<a-col :span="6">
					<a-form-item label="咨询类型" name="typeId">
						<a-select v-model:value="searchFormState.typeId" :options="consultTypeData" placeholder="请选择咨询类型"/>
					</a-form-item>
				</a-col>

				<a-col :span="6">
					<a-form-item label="处理状态" name="contactStatus">
						<a-select v-model:value="searchFormState.contactStatus" placeholder="请选择处理状态"
								  :options="Sys.status" allow-clear/>
					</a-form-item>
				</a-col>

				<a-col :span="6">
					<a-button type="primary" @click="table.refresh(true)">查询</a-button>
					<a-button style="margin: 0 8px" @click="reset">重置</a-button>
				</a-col>
			</a-row>
		</a-form>
		<s-table
			ref="table"
			:columns="columns"
			:data="loadData"
			:alert="options.alert.show"
			bordered
			:row-key="(record) => record.id"
			:tool-config="toolConfig"
			:row-selection="options.rowSelection"
		>
			<template #operator class="table-operator">
			</template>
			<template #bodyCell="{ column, record }">
				<template v-if="column.dataIndex === 'contactStatus'">
					<a-tag :color="record.contactStatus ? Sys.status[1].color : Sys.status[0].color">
						{{ record.contactStatus ? Sys.status[1].label : Sys.status[0].label }}
					</a-tag>
				</template>
				<template v-if="column.dataIndex === 'action'">
					<a-space>
						<a @click="formRef.onOpen(record)" v-if="hasPerm('website:consult:save')">处理</a>
					</a-space>
				</template>
			</template>
		</s-table>
	</a-card>
	<Handle ref="formRef" @successful="table.refresh(true)"/>
</template>

<script setup name="consult">

import Handle from './handle.vue'
import consultApi from '@/api/website/consultApi'
import consultTypeApi from '@/api/website/consultTypeApi'
import {Sys} from "@/utils/constant";

let searchFormState = reactive({})
const searchFormRef = ref()
const table = ref()
const formRef = ref()
const toolConfig = {refresh: true, height: true, columnSetting: true, striped: false}
const columns = [
	{
		title: '姓名',
		dataIndex: 'name'
	},
	{
		title: '电话',
		dataIndex: 'phone'
	},
	{
		title: '邮箱',
		dataIndex: 'email'
	},
	{
		title: '咨询类型',
		dataIndex: 'typeName'
	},
	{
		title: '创建时间',
		dataIndex: 'createdAt'
	},
	{
		title: '处理状态',
		dataIndex: 'contactStatus'
	},
]
// 操作栏通过权限判断是否显示
if (hasPerm(['website:case:edit', 'website:case:delete'])) {
	columns.push({
		title: '操作',
		dataIndex: 'action',
		align: 'center',
		width: '150px'
	})
}
const selectedRowKeys = ref([])
// 列表选择配置
const options = {
	// columns数字类型字段加入 needTotal: true 可以勾选自动算账
	alert: {
		show: true,
		clear: () => {
			selectedRowKeys.value = ref([])
		}
	},
	rowSelection: {
		onChange: (selectedRowKey, selectedRows) => {
			selectedRowKeys.value = selectedRowKey
		}
	}
}
const loadData = (parameter) => {
	const searchFormParam = JSON.parse(JSON.stringify(searchFormState))
	return consultApi.page(Object.assign(parameter, searchFormParam)).then((data) => {
		return data
	})
}
// 重置
const reset = () => {
	searchFormRef.value.resetFields()
	table.value.refresh(true)
}
// 删除
const deleteInfo = (record) => {
	let params = [
		record.id,
	]
	consultApi.deleteData(params).then(() => {
		table.value.refresh(true)
	})
}
// 批量删除
const deleteBatchInfo = (params) => {
	consultApi.deleteData(params).then(() => {
		table.value.clearRefreshSelected()
	})
}

// 初始化咨询类型
const consultTypeData = ref([])
const initConsultTypeType = () => {
	consultTypeApi.list({}).then(res => {
		consultTypeData.value = res.map(x => {
			return {label: x.name, value: x.id}
		})
	})
}
initConsultTypeType()
</script>
